#!/sw/bin/perl

###############################################################################
##                                                                           ##
##    "match" version 1.0 (16-Dec-1998)                                      ##
##                                                                           ##
##    Copyright (c) 1998 by Steffen Beyer. All rights reserved.              ##
##                                                                           ##
##    This program is free software; you can redistribute it                 ##
##    and/or modify it under the same terms as Perl itself.                  ##
##                                                                           ##
###############################################################################

# Usage: match [-i] perlregexp [<string> ...]

$self = $0;
$self =~ s!^.*/!!;

$ignore_case = 0;
if (@ARGV && $ARGV[0] eq '-i')
{
    shift;
    $ignore_case = 1;
}

unless (@ARGV)
{
    die "Usage: $self [-i] perlregexp [<string> ...]\n";
}

$reg_exp = shift;

$_ = '';
eval { /$reg_exp/o };
if ($@)
{
    if ($@ =~ /^(.+?)\s+at\s/) { die "$self: $1!\n"; }
    else                       { die "$self: $@"; }
}

chomp(@ARGV = <STDIN>) unless (@ARGV);

if ($ignore_case)
{
    foreach $_ (@ARGV) { print "$_\n" if (/$reg_exp/io); }
}
else
{
    foreach $_ (@ARGV) { print "$_\n" if (/$reg_exp/o); }
}

__END__

